#!/bin/sh
# /home/abacus/pm3co/scanner_eng.tcl 
# the next line restarts using wish \
exec wish "$0" "$@" -geometry +0+0
########################################################################
#
# Rigid 
#
# Initial version 991117
# 
# 
########################################################################

set NODE pm3sn

Pic copy Pic_pm3_scanner_eng 

 
set ww 30
set yy 30
set yyincr 30
#  -background red -activebackground red\

proc set_value { typ blkno value } {
	global NODE
	set eng4_pipe_multi [socket $NODE 9000]
	fconfigure $eng4_pipe_multi -buffering line
	puts $eng4_pipe_multi "/home/abacus/eng4 "

	puts $eng4_pipe_multi "$typ$blkno $value"
	catch { set str_ [gets $eng4_pipe_multi] }
	catch { close $eng4_pipe_multi }
}

button $w.p.ti_eng  -text "SCANNER ENG-MODE" -width $ww \
  -command {
     if { [vn 11001] } {
     set_value am 15001 0
     set_value am 15002 0
     set_value am 15003 0
     set_value am 15004 0
     set_value am 15005 0
     set_value vn 11002 1
     set_value vn 11003 1
     }
     set_value vn 11001 [expr ![vn 11001]]
  }
place $w.p.ti_eng -x 30 -y $yy 

button $w.p.ti_fwd  -text "FORWARD" -width $ww \
 -command { 
   set_value am 15001 [expr ![vn 15001]]
   set_value vn 15001 [expr ![vn 15001]]
   }
incr yy $yyincr
place $w.p.ti_fwd -x 30 -y $yy 

button $w.p.ti_rev  -text "REVERSE"  -width $ww \
 -command { 
   set_value am 15002 [expr ![vn 15002]]
   set_value vn 15002 [expr ![vn 15002]]
   }
incr yy $yyincr
place $w.p.ti_rev  -x 30 -y $yy 

button $w.p.ti_max  -text "MAX SPEED"  -width $ww \
 -command { set_value vn 15004 [expr ![vn 15004]]}
incr yy $yyincr
place $w.p.ti_max -x 30 -y $yy 

button $w.p.ti_scan  -text "SCAN"  -width $ww \

# -command { set_value vn 15003 [expr ![vn 15003]]}

incr yy $yyincr
place $w.p.ti_scan -x 30 -y $yy 

button $w.p.ti_shutter  -text "SHUTTER"  -width $ww \
 -command {
   set_value am 15005 [expr ![vn 15005]]
   set_value vn 15005 [expr ![vn 15005]]
   }
incr yy $yyincr
place $w.p.ti_shutter -x 30 -y $yy 

button $w.p.ti_uheater  -text "UPPER HEAD HEATER"  -width $ww \
 -command { set_value am 14522 [expr ![vn 14522]]}
incr yy $yyincr
place $w.p.ti_uheater -x 30 -y $yy 

button $w.p.ti_lheater  -text "LOWER HEAD HEATER"  -width $ww \
 -command { set_value am 14532 [expr ![vn 14532]]}
incr yy $yyincr
place $w.p.ti_lheater -x 30 -y $yy 


button $w.p.ti_uheaters  -text "UPPER HEAD HEATER AUTO"  -width $ww \
 -command { set_value vn 11002 [expr ![vn 11002]]}
incr yy $yyincr
place $w.p.ti_uheaters -x 30 -y $yy 


button $w.p.ti_lheaters  -text "LOWER HEAD HEATER AUTO"  -width $ww \
 -command { set_value vn 11003 [expr ![vn 11003]]}
incr yy $yyincr
place $w.p.ti_lheaters -x 30 -y $yy 


set xmax 0 ; set ymax 400 ; set resol 1 ;
set max 10000 ; set min 0 ;
    catch { set headposraw [ra 8011] }
    get_values
    catch { set headposraw [ra 8011] }
catch { scale $w.p.sc_headposraw -from $max -to $min -length 600 -variable headposraw \
	-orient horizontal -fg yellow -bg darkred -tickinterval [expr ( $max - $min ) / 4] \
	-resolution $resol } scalecatch
catch { place $w.p.sc_headposraw -x 10 -y 341 } placecatch

set ww 15
set xx 10
set yy 400
set xxincr 150
button $w.p.ti_park  -text "PARK" -width $ww \
 -command {
  set_value am 11006 1 ; set_value vn 11006 1
  set_value am 11007 0 ; set_value vn 11007 0
  }
place $w.p.ti_park -x $xx -y $yy 
incr xx $xxincr

button $w.p.ti_SCAN  -text "SCAN" -width $ww \
 -command {
  set_value am 11006 0 ; set_value vn 11006 0
  set_value am 11007 1 ; set_value vn 11007 1
  }
place $w.p.ti_SCAN -x $xx -y $yy 
incr xx $xxincr

button $w.p.ti_std  -text "STD " -width $ww \
 -command { set_value am 11008 1 ; set_value vn 11008 1}
place $w.p.ti_std -x $xx -y $yy 
incr xx $xxincr

		

############## This is the main dynamic data updating proc ##################
#
#
#

proc update0 {} {
  global w fulltime halftime time_taken fg bg blinkon lfont
  global headposraw

  set time_taken [ time	{
    get_values

    if { [winfo viewable .] } {

#
    set xx 280
    set yy 55
    set lfont {courier 24 normal}
    set lfont {courier 24 bold}
    set lfont {helvetica 24 bold}
    set lfont -*-helvetica-bold-r-*-*-16-*-*-*-*-*-*-*
    set lfont {helvetica 16 bold}

    catch { text_item la0 $xx  $yy  "GSM VOLTS %8.3f" [ra 233] } ;    incr yy 30
    catch { text_item la1 $xx  $yy  "MOISTURE SIGNAL %8.2f" [ra 9955] } ;    incr yy 30
    catch { text_item la2 $xx  $yy  "SCALED RAW GSM %8.2f" [ra 5063] } ;
    incr yy 30
#    catch { text_item la3 $xx  $yy  "%8.2f" [ra 7117] } ;
    incr yy 30
#    catch { text_item la4 $xx  $yy  "%8.2f" [ra 7117] } ;
    incr yy 30
#    catch { text_item la5 $xx  $yy  "%8.2f" [ra 7117] } ;
    incr yy 30
#    catch { text_item la6 $xx  $yy  "%8.2f" [ra 7117] } ;
    incr yy 30
#    catch { text_item la7 $xx  $yy  "%8.2f" [ra 7117] } ;
    incr yy 30
    catch { text_item la8 $xx  $yy  "UPPER HEAD TEMP %8.2f" [ra 227] } ;    incr yy 30
    catch { text_item la9 $xx  $yy  "LOWER HEAD TEMP %8.2f" [ra 235] } ;    incr yy 30
    catch { $w.p.tila0 configure -justify right -width 34 }
    catch { $w.p.tila1 configure -justify right -width 34 }
    catch { $w.p.tila2 configure -justify right -width 34 }
    catch { $w.p.tila3 configure -justify right -width 34 }
    catch { $w.p.tila4 configure -justify right -width 34 }
    catch { $w.p.tila5 configure -justify right -width 34 }
    catch { $w.p.tila6 configure -justify right -width 34 }
    catch { $w.p.tila7 configure -justify right -width 34 }
    catch { $w.p.tila8 configure -justify right -width 34 }
    catch { $w.p.tila9 configure -justify right -width 34 }
    
    catch { set headposraw [ra 8011] }


    catch { if { [vn 11001] } then {
      $w.p.ti_fwd      configure -state normal
      $w.p.ti_rev      configure -state normal
      $w.p.ti_max      configure -state normal
      $w.p.ti_scan     configure -state normal
      $w.p.ti_shutter  configure -state normal
      $w.p.ti_uheater  configure -state normal
      $w.p.ti_lheater  configure -state normal
      $w.p.ti_uheaters configure -state normal
      $w.p.ti_lheaters configure -state normal
      $w.p.ti_eng configure -text "SCANNER ENG (ENABLED)" \
       -background green -activebackground green } else {
     
      $w.p.ti_fwd      configure -state disabled
      $w.p.ti_rev      configure -state disabled
      $w.p.ti_max      configure -state disabled
      $w.p.ti_scan     configure -state disabled
      $w.p.ti_shutter  configure -state disabled
      $w.p.ti_uheater  configure -state disabled
      $w.p.ti_lheater  configure -state disabled
      $w.p.ti_uheaters configure -state disabled
      $w.p.ti_lheaters configure -state disabled

      $w.p.ti_eng configure -text "SCANNER ENG (DISABLED)"  \
       -background red -activebackground red } }
    catch { vn 15001 }
    catch { vn 15002 }
    catch { vn 15003 }
    catch { vn 15004 }
    catch { vn 15005 }
    
    catch { if { [vn 14501] } then {
      $w.p.ti_fwd configure -text "FORWARD (ON)" \
       -background green -activebackground green } else {
      $w.p.ti_fwd configure -text "FORWARD (OFF)"  \
       -background red -activebackground red } }

    catch { if { [vn 14502] } then {
      $w.p.ti_rev configure -text "REVERSE (ON)" \
       -background green -activebackground green } else {
      $w.p.ti_rev configure -text "REVERSE (OFF)"  \
       -background red -activebackground red } }

    catch { if { [vn 14504] } then {
      $w.p.ti_max configure -text "MAX SPEED (ON)" \
       -background green -activebackground green } else {
      $w.p.ti_max configure -text "MAX SPEED (OFF)"  \
       -background red -activebackground red } }

    catch { if { [vn 14503] } then {
      $w.p.ti_scan configure -text "SCAN (ON)" \
       -background green -activebackground green } else {
      $w.p.ti_scan configure -text "SCAN (OFF)"  \
       -background red -activebackground red } }

    catch { if { [vn 14505] } then {
      $w.p.ti_shutter configure -text "SHUTTER (ON)" \
       -background green -activebackground green } else {
      $w.p.ti_shutter configure -text "SHUTTER (OFF)"  \
       -background red -activebackground red } }

    catch { if { [vn 14522] } then {
      $w.p.ti_uheater configure -text "UPPER HEAD HEATER (ON)" \
       -background green -activebackground green } else {
      $w.p.ti_uheater configure -text "UPPER HEAD HEATER (OFF)"  \
       -background red -activebackground red } }

    catch { if { [vn 14532] } then {
      $w.p.ti_lheater configure -text "LOWER HEAD HEATER (ON)" \
       -background green -activebackground green } else {
      $w.p.ti_lheater configure -text "LOWER HEAD HEATER (OFF)"  \
       -background red -activebackground red } }

    catch { if { [vn 11002] } then {
      $w.p.ti_uheaters configure -text "UPPER HEAD HEATER AUTO (AUTO)" \
       -background green -activebackground green } else {
      $w.p.ti_uheaters configure -text "UPPER HEAD HEATER AUTO (HAND)"  \
       -background red -activebackground red } }

    catch { if { [vn 11003] } then {
      $w.p.ti_lheaters configure -text "LOWER HEAD HEATER AUTO (AUTO)" \
       -background green -activebackground green } else {
      $w.p.ti_lheaters configure -text "LOWER HEAD HEATER AUTO (HAND)"  \
       -background red -activebackground red } }


	  catch {
	   if {[vn 2691]} {
	     $w.p.ti_park configure -text "PARKED"
	   } else {
	     if {[vn 11006]} { 
		  $w.p.ti_park configure -text "PARK REQ"
	     } else {
		  $w.p.ti_park configure -text "PARK" }
	     }
	  }

	  catch {
	   if {[vn 1053]} {
	     $w.p.ti_SCAN configure -text "SCANNING"
	   } else {
	     if {[vn 11007]} { 
		  $w.p.ti_SCAN configure -text "SCAN REQ"
	     } else {
		  $w.p.ti_SCAN configure -text "SCAN" }
	     }
	  }

	  catch {
	   if {[vn 2132]} {
	     $w.p.ti_std configure -text "STANDARDIZING"
	   } else {
	     if {[vn 11008]} { 
		  $w.p.ti_std configure -text "STD REQ"
	     } else {
		  $w.p.ti_std configure -text "STANDARDIZE" }
	     }
	  }

 	} } ]
################# Here we queue up this proc again ##########################

      show_time $time_taken
      set fulltime2 [expr $fulltime * 1]
      after $fulltime2 update0
      }


get_values

update0

